﻿var myScale = app.activeDocument.viewPreferences.horizontalMeasurementUnits;
var tmpS = "";
if (myScale == 2054188905) tmpS = "pt";
if (myScale == 2053991795) tmpS = "mm";
var sel = app.activeDocument.selection[0];
var tfSize = sel.visibleBounds[3] - sel.visibleBounds[1];

if (sel.constructor.name == "TextFrame" ) {
	var clist = "";
	for(i=0; i<app.activeDocument.swatches.length; i++) {
		clist = clist + app.activeDocument.swatches[i].name + ",";
		}
	clist = clist.replace ("None,Paper,Black,Registration,", "Black,");
	clist = clist.substring (0, clist.length-1);
	clist = clist.split (",");
	dlg = app.dialogs.add({name:"グラデーションでタテ罫"});
	dlc = dlg.dialogColumns.add();
	with(dlc.dialogRows.add()){
		staticTexts.add({staticLabel:"色"});
		selColor = dropdowns.add({stringList: clist, selectedIndex:0});}
	with(dlc.dialogRows.add()){ 
		staticTexts.add({staticLabel:"サイズ"});
		tmpSize = realEditboxes.add({editValue:1,minimumValue:0.1,maximumValue:tfSize});
        staticTexts.add({staticLabel:tmpS});
		}
	flag = dlg.show();

	if (flag == true) {
		var mySize = tmpSize.editValue;
		var myColor = selColor.stringList[selColor.selectedIndex];
		try {
            tmp = app.activeDocument.swatches.item(myColor).gradientStops.length;
            alert("グラデーションスウォッチは選択しないでください");
            exit();
            } catch(e) {}
		sel.fillColor = app.activeDocument.gradients[-1];
		sel.fillColor.type = GradientType.LINEAR; //円形を線形にした場合、おかしい
		sel.gradientFillAngle = 0;
		var grStop = sel.fillColor.gradientStops;
		if (grStop.length > 2) {
            for (i = grStop.length-1; i > 2; i--) {
                grStop[i].remove();
                }
            }
        grStop[0].location = 0;
        grStop[1].location = 100;
		while(grStop.length < 4) {
            grStop.add();
            }
		grStop[0].stopColor = app.activeDocument.swatches.item(myColor);
		grStop[0].location = 0;
		grStop[1].stopColor = app.activeDocument.swatches.item(myColor);
		grStop[1].location = mySize/tfSize * 100;
		grStop[2].stopColor = app.activeDocument.swatches.item("Paper");
		grStop[2].location = mySize/tfSize * 100 + 0.00000000001;
		grStop[3].stopColor = app.activeDocument.swatches.item("Paper");
		}
	}